//
//  PowerPCIQInstruction.h
//  PowerPCIQFramework
//
//  Created by 2510 on Tue Feb 25 2003.
//  Copyright (c) 2003 by 2510. All rights reserved.
//
//  << TEXT ENCODING : UTF-8 >>
//

#import <Foundation/Foundation.h>

#define PowerPCIQ_COND_LT		0x00
#define PowerPCIQ_COND_GT		0x01
#define PowerPCIQ_COND_EQ		0x02
#define PowerPCIQ_COND_SO		0x03

#define PowerPCIQ_COND_TRUE		0x0C
#define PowerPCIQ_COND_FALSE	0x04
#define PowerPCIQ_COND_DEC_NZ	0x10
#define PowerPCIQ_COND_DEC_ZR	0x12
#define PowerPCIQ_COND_ALWAYS	0x14

#define PowerPCIQ_SPR_XER		0x020
#define PowerPCIQ_SPR_LR		0x100
#define PowerPCIQ_SPR_CTR		0x120
#define PowerPCIQ_SPR_VRSAVE	0x008

unsigned long *PowerPCIQ_ADD_(void *context,int rd,int ra,int rb,int OE,int Rc);
#define PowerPCIQ_ADD(context,rd,ra,rb,Rc)			PowerPCIQ_ADD_(context,rd,ra,rb,0,Rc)
#define PowerPCIQ_ADDO(context,rd,ra,rb,Rc)			PowerPCIQ_ADD_(context,rd,ra,rb,1,Rc)

unsigned long *PowerPCIQ_ADDI(void *context,int rd,int ra,short immediate);
unsigned long *PowerPCIQ_ADDIC(void *context,int rd,int ra,short immediate);
unsigned long *PowerPCIQ_ADDICrec(void *context,int rd,int ra,short immediate);
unsigned long *PowerPCIQ_ADDIS(void *context,int rd,int ra,short immediate);
unsigned long *PowerPCIQ_AND(void *context,int rd,int ra,int rb,int Rc);
unsigned long *PowerPCIQ_ANDC(void *context,int rd,int ra,int rb,int Rc);
unsigned long *PowerPCIQ_ANDI(void *context,int rd,int ra,short immediate);
unsigned long *PowerPCIQ_ANDIS(void *context,int rd,int ra,short immediate);

unsigned long *PowerPCIQ_B_(void *context,int offset,int AA,int LK); // SYNC
unsigned long *PowerPCIQ_BC_(void *context,int cr,int field,int tf,int offset,int AA,int LK); // SYNC
unsigned long *PowerPCIQ_BCCTR_(void *context,int cr,int field,int tf,int LK); // SYNC
unsigned long *PowerPCIQ_BCLR_(void *context,int cr,int field,int tf,int LK); // SYNC
#define PowerPCIQ_B(context,offset)					PowerPCIQ_B_(context,offset,0,0)
#define PowerPCIQ_BA(context,offset)				PowerPCIQ_B_(context,offset,1,0)
#define PowerPCIQ_BC(context,cr,field,tf,offset)	PowerPCIQ_BC_(context,cr,field,tf,offset,0,0)
#define PowerPCIQ_BCCTR(context,cr,field,tf)		PowerPCIQ_BCCTR_(context,cr,field,tf,0)
#define PowerPCIQ_BCCTRL(context,cr,field,tf)		PowerPCIQ_BCCTR_(context,cr,field,tf,1)
#define PowerPCIQ_BCL(context,cr,field,tf,offset)	PowerPCIQ_BC_(context,cr,field,tf,offset,0,1)
#define PowerPCIQ_BCLA(context,cr,field,tf,offset)	PowerPCIQ_BC_(context,cr,field,tf,offset,1,1)
#define PowerPCIQ_BCLR(context,cr,field,tf)			PowerPCIQ_BCLR_(context,cr,field,tf,0)
#define PowerPCIQ_BCTR(context)						PowerPCIQ_BCCTR_(context,0,0,PowerPCIQ_COND_ALWAYS,0)
#define PowerPCIQ_BCTRL(context)					PowerPCIQ_BCCTR_(context,0,0,PowerPCIQ_COND_ALWAYS,1)
#define PowerPCIQ_BDNZ(context,offset)				PowerPCIQ_BC_(context,0,0,PowerPCIQ_COND_DEC_NZ,offset,0)
#define PowerPCIQ_BDNZLR(context)					PowerPCIQ_BCLR_(context,0,0,PowerPCIQ_COND_DEC_NZ,0)
#define PowerPCIQ_BDZ(context,offset)				PowerPCIQ_BC_(context,0,0,PowerPCIQ_COND_DEC_ZR,offset,0)
#define PowerPCIQ_BDZLR(context)					PowerPCIQ_BCLR_(context,0,0,PowerPCIQ_COND_DEC_ZR,0)
#define PowerPCIQ_BL(context,offset)				PowerPCIQ_B_(context,offset,0,1)
#define PowerPCIQ_BLA(context,offset)				PowerPCIQ_B_(context,offset,1,1)
#define PowerPCIQ_BLT(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_LT,PowerPCIQ_COND_TRUE,offset,0,0)
#define PowerPCIQ_BLTCTR(context,cr)				PowerPCIQ_BCCTR_(context,cr,PowerPCIQ_COND_LT,PowerPCIQ_COND_TRUE,0,0)
#define PowerPCIQ_BLTL(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_LT,PowerPCIQ_COND_TRUE,offset,0,1)
#define PowerPCIQ_BLTLR(context,cr)					PowerPCIQ_BCLR_(context,cr,PowerPCIQ_COND_LT,PowerPCIQ_COND_TRUE,0,0)
#define PowerPCIQ_BLE(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_GT,PowerPCIQ_COND_FALSE,offset,0,0)
#define PowerPCIQ_BLECTR(context,cr)				PowerPCIQ_BCCTR_(context,cr,PowerPCIQ_COND_GT,PowerPCIQ_COND_FALSE,0,0)
#define PowerPCIQ_BLEL(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_GT,PowerPCIQ_COND_FALSE,offset,0,1)
#define PowerPCIQ_BLELR(context,cr)					PowerPCIQ_BCLR_(context,cr,PowerPCIQ_COND_GT,PowerPCIQ_COND_FALSE,0,0)
#define PowerPCIQ_BGT(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_GT,PowerPCIQ_COND_TRUE,offset,0,0)
#define PowerPCIQ_BGTCTR(context,cr)				PowerPCIQ_BCCTR_(context,cr,PowerPCIQ_COND_GT,PowerPCIQ_COND_TRUE,0,0)
#define PowerPCIQ_BGTL(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_GT,PowerPCIQ_COND_TRUE,offset,0,1)
#define PowerPCIQ_BGTLR(context,cr)					PowerPCIQ_BCLR_(context,cr,PowerPCIQ_COND_GT,PowerPCIQ_COND_TRUE,0,0)
#define PowerPCIQ_BGE(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_LT,PowerPCIQ_COND_FALSE,offset,0,0)
#define PowerPCIQ_BGECTR(context,cr)				PowerPCIQ_BCCTR_(context,cr,PowerPCIQ_COND_LT,PowerPCIQ_COND_FALSE,0,0)
#define PowerPCIQ_BGEL(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_LT,PowerPCIQ_COND_FALSE,offset,0,1)
#define PowerPCIQ_BGELR(context,cr)					PowerPCIQ_BCLR_(context,cr,PowerPCIQ_COND_LT,PowerPCIQ_COND_FALSE,0,0)
#define PowerPCIQ_BEQ(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_EQ,PowerPCIQ_COND_TRUE,offset,0,0)
#define PowerPCIQ_BEQCTR(context,cr)				PowerPCIQ_BCCTR_(context,cr,PowerPCIQ_COND_EQ,PowerPCIQ_COND_TRUE,0,0)
#define PowerPCIQ_BEQL(offset,cr)					PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_EQ,PowerPCIQ_COND_TRUE,offset,0,1)
#define PowerPCIQ_BEQLR(context,cr)					PowerPCIQ_BCLR_(context,cr,PowerPCIQ_COND_EQ,PowerPCIQ_COND_TRUE,0,0)
#define PowerPCIQ_BNE(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_EQ,PowerPCIQ_COND_FALSE,offset,0,0)
#define PowerPCIQ_BNECTR(context,cr)				PowerPCIQ_BCCTR_(context,cr,PowerPCIQ_COND_EQ,PowerPCIQ_COND_FALSE,0,0)
#define PowerPCIQ_BNEL(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_EQ,PowerPCIQ_COND_FALSE,offset,0,1)
#define PowerPCIQ_BNELR(context,cr)					PowerPCIQ_BCLR_(context,cr,PowerPCIQ_COND_EQ,PowerPCIQ_COND_FALSE,0,0)
#define PowerPCIQ_BNS(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_SO,PowerPCIQ_COND_FALSE,offset,0,0)
#define PowerPCIQ_BNSCTR(context,cr)				PowerPCIQ_BCCTR_(context,cr,PowerPCIQ_COND_SO,PowerPCIQ_COND_FALSE,0,0)
#define PowerPCIQ_BNSL(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_SO,PowerPCIQ_COND_FALSE,offset,0,1)
#define PowerPCIQ_BNSLR(context,cr)					PowerPCIQ_BCLR_(context,cr,PowerPCIQ_COND_SO,PowerPCIQ_COND_FALSE,0,0)
#define PowerPCIQ_BLR(context)						PowerPCIQ_BCLR_(context,0,0,PowerPCIQ_COND_ALWAYS,0)
#define PowerPCIQ_BSO(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_SO,PowerPCIQ_COND_TRUE,offset,0,0)
#define PowerPCIQ_BSOCTR(context,cr)				PowerPCIQ_BCCTR_(context,cr,PowerPCIQ_COND_SO,PowerPCIQ_COND_TRUE,0,0)
#define PowerPCIQ_BSOL(context,cr,offset)			PowerPCIQ_BC_(context,cr,PowerPCIQ_COND_SO,PowerPCIQ_COND_TRUE,offset,0,1)
#define PowerPCIQ_BSOLR(context,cr)					PowerPCIQ_BCLR_(context,cr,PowerPCIQ_COND_SO,PowerPCIQ_COND_TRUE,0,0)

unsigned long *PowerPCIQ_CMP(void *context,int cr,int ra,int rb);
unsigned long *PowerPCIQ_CMPI(void *context,int cr,int ra,short immediate);
unsigned long *PowerPCIQ_CMPL(void *context,int cr,int ra,int rb);
unsigned long *PowerPCIQ_CMPLI(void *context,int cr,int ra,unsigned short immediate);

unsigned long *PowerPCIQ_CNTLZW(void *context,int rd,int ra,int Rc);
unsigned long *PowerPCIQ_CRAND(void *context,int crD,int crA,int crB);
unsigned long *PowerPCIQ_CRANDC(void *context,int crD,int crA,int crB);
unsigned long *PowerPCIQ_CREQV(void *context,int crD,int crA,int crB);
unsigned long *PowerPCIQ_CRNAND(void *context,int crD,int crA,int crB);
unsigned long *PowerPCIQ_CRNOR(void *context,int crD,int crA,int crB);
unsigned long *PowerPCIQ_CROR(void *context,int crD,int crA,int crB);
unsigned long *PowerPCIQ_CRORC(void *context,int crD,int crA,int crB);
unsigned long *PowerPCIQ_CRXOR(void *context,int crD,int crA,int crB);
#define PowerPCIQ_CRSET(context,crD)	PowerPCIQ_CREQV(context,crD,crD,crD)
#define PowerPCIQ_CRCLR(context,crD)	PowerPCIQ_CRXOR(context,crD,crD,crD)
#define PowerPCIQ_CRNOT(context,crD)	PowerPCIQ_CRNOR(context,crD,crD,crD)

unsigned long *PowerPCIQ_DCBT(void *context,int ra,int rb);
unsigned long *PowerPCIQ_DCBTST(void *context,int ra,int rb);
unsigned long *PowerPCIQ_DCBZ(void *context,int ra,int rb);

unsigned long *PowerPCIQ_DIVW_(void *context,int rd,int ra,int rb,int Rc);
unsigned long *PowerPCIQ_DIVWU_(void *context,int rd,int ra,int rb,int Rc);
#define PowerPCIQ_DIVW(context,rd,ra,rb)	PowerPCIQ_DIVW_(context,rd,ra,rb,0)
#define PowerPCIQ_DIVWU(context,rd,ra,rb)	PowerPCIQ_DIVWU_(context,rd,ra,rb,0)

unsigned long *PowerPCIQ_EXTSB_(void *context,int rd,int ra,int Rc);
unsigned long *PowerPCIQ_EXTSH_(void *context,int rd,int ra,int Rc);
#define PowerPCIQ_EXTSB(context,rd,ra)	PowerPCIQ_EXTSB_(context,rd,ra,0)
#define PowerPCIQ_EXTSH(context,rd,ra)	PowerPCIQ_EXTSH_(context,rd,ra,0)

unsigned long *PowerPCIQ_EQV_(void *context,int rd,int ra,int rb,int Rc);
#define PowerPCIQ_EQV(context,rd,ra,rb)	PowerPCIQ_EQV_(context,rd,ra,rb,0)

unsigned long *PowerPCIQ_LBZ(void *context,int rd,int ra,short offset);
unsigned long *PowerPCIQ_LBZX(void *context,int rd,int ra,int rb);

unsigned long *PowerPCIQ_LHA(void *context,int rd,int ra,short offset);
unsigned long *PowerPCIQ_LHAU(void *context,int rd,int ra,short offset);
unsigned long *PowerPCIQ_LHAUX(void *context,int rd,int ra,int rb);
unsigned long *PowerPCIQ_LHAX(void *context,int rd,int ra,int rb);

unsigned long *PowerPCIQ_LHBRX(void *context,int rd,int ra,int rb);

unsigned long *PowerPCIQ_LHZ(void *context,int rd,int ra,short offset);
unsigned long *PowerPCIQ_LHZU(void *context,int rd,int ra,short offset);
unsigned long *PowerPCIQ_LHZUX(void *context,int rd,int ra,int rb);
unsigned long *PowerPCIQ_LHZX(void *context,int rd,int ra,int rb);

#define PowerPCIQ_LI(context,rd,immediate)	PowerPCIQ_ADDI(context,rd,0,immediate)
#define PowerPCIQ_LIS(context,rd,immediate)	PowerPCIQ_ADDIS(context,rd,0,immediate)

unsigned long *PowerPCIQ_LMW(void *context,int rd,int ra,short offset); // SYNC
unsigned long *PowerPCIQ_LSWI(void *context,int rd,int ra,int nb); // SYNC
unsigned long *PowerPCIQ_LSWX(void *context,int rd,int ra,int rb); // SYNC

unsigned long *PowerPCIQ_LWBRX(void *context,int rd,int ra,int rb);

unsigned long *PowerPCIQ_LWZ(void *context,int rd,int ra,short offset);
unsigned long *PowerPCIQ_LWZU(void *context,int rd,int ra,short offset);
unsigned long *PowerPCIQ_LWZUX(void *context,int rd,int ra,int rb);
unsigned long *PowerPCIQ_LWZX(void *context,int rd,int ra,int rb);

unsigned long *PowerPCIQ_MFCR(void *context,int rd);
unsigned long *PowerPCIQ_MFSPR(void *context,int rd,int spr);
#define PowerPCIQ_MFCTR(context,rd)		PowerPCIQ_MFSPR(context,rd,PowerPCIQ_SPR_CTR)
#define PowerPCIQ_MFLR(context,rd)		PowerPCIQ_MFSPR(context,rd,PowerPCIQ_SPR_LR)
#define PowerPCIQ_MFXER(context,rd)		PowerPCIQ_MFSPR(context,rd,PowerPCIQ_SPR_XER)
#define PowerPCIQ_MFVRSAVE(context,rd)	PowerPCIQ_MFSPR(context,rd,PowerPCIQ_SPR_VRSAVE)

#define PowerPCIQ_MR(context,rd,ra,Rc)	PowerPCIQ_OR(context,rd,ra,ra,Rc)

unsigned long *PowerPCIQ_MTCRF(void *context,int ra,int crm);
unsigned long *PowerPCIQ_MTSPR(void *context,int ra,int spr);
#define PowerPCIQ_MTCTR(context,ra)		PowerPCIQ_MTSPR(context,ra,PowerPCIQ_SPR_CTR)
#define PowerPCIQ_MTLR(context,ra)		PowerPCIQ_MTSPR(context,ra,PowerPCIQ_SPR_LT)
#define PowerPCIQ_MTXER(context,ra)		PowerPCIQ_MTSPR(context,ra,PowerPCIQ_SPR_XER)
#define PowerPCIQ_MTVRSAVE(context,ra)	PowerPCIQ_MTSPR(context,ra,PowerPCIQ_SPR_VRSAVE)

unsigned long *PowerPCIQ_MULLW_(void *context,int rd,int ra,int rb,int Rc);
unsigned long *PowerPCIQ_MULLI(void *context,int rd,int ra,short immediate);
unsigned long *PowerPCIQ_MULHW_(void *context,int rd,int ra,int rb,int Rc);
unsigned long *PowerPCIQ_MULHWU_(void *context,int rd,int ra,int rb,int Rc);
#define PowerPCIQ_MULLW(context,rd,ra,rb)	PowerPCIQ_MULLW_(context,rd,ra,rb,0)
#define PowerPCIQ_MULHW(context,rd,ra,rb)	PowerPCIQ_MULHW_(context,rd,ra,rb,0)
#define PowerPCIQ_MULHWU(context,rd,ra,rb)	PowerPCIQ_MULHWU_(context,rd,ra,rb,0)

unsigned long *PowerPCIQ_NEG(void *context,int rd,int ra,int Rc);
unsigned long *PowerPCIQ_NOR(void *context,int rd,int ra,int rb,int Rc);
#define PowerPCIQ_NOP(context)			PowerPCIQ_OR(context,0,0)
#define PowerPCIQ_NOT(context,rd,ra,Rc)	PowerPCIQ_NOR(context,rd,ra,ra,Rc)

unsigned long *PowerPCIQ_OR(void *context,int rd,int ra,int rb,int Rc);
unsigned long *PowerPCIQ_ORC(void *context,int rd,int ra,int rb,int Rc);
unsigned long *PowerPCIQ_ORI(void *context,int rd,int ra,unsigned short immediate);
unsigned long *PowerPCIQ_ORIS(void *context,int rd,int ra,unsigned short immediate);

unsigned long *PowerPCIQ_RLWNM(void *context,int rd,int ra,int rb,int mb,int me,int Rc);
unsigned long *PowerPCIQ_RLWIMI(void *context,int rd,int ra,int sh,int mb,int me,int Rc);
unsigned long *PowerPCIQ_RLWINM(void *context,int rd,int ra,int sh,int mb,int me,int Rc);

unsigned long *PowerPCIQ_SLW(void *context,int rd,int ra,int rb,int Rc);
unsigned long *PowerPCIQ_SRAW(void *context,int rd,int ra,int rb,int Rc);
unsigned long *PowerPCIQ_SRAWI(void *context,int rd,int ra,int sa,int Rc);
unsigned long *PowerPCIQ_SRW(void *context,int rd,int ra,int rb,int Rc);
#define PowerPCIQ_SLWI(context,rd,rs,sh,Rc)	PowerPCIQ_RLWINM(context,rd,rs,sh,0,31 - sh,Rc)
#define PowerPCIQ_SRWI(context,rd,rs,sh,Rc)	PowerPCIQ_RLWINM(context,rd,rs,32 - sh,sh,31,Rc)

unsigned long *PowerPCIQ_STB(void *context,int rs,int ra,short offset);
unsigned long *PowerPCIQ_STBU(void *context,int rs,int ra,short offset);
unsigned long *PowerPCIQ_STBUX(void *context,int rs,int ra,int rb);
unsigned long *PowerPCIQ_STBX(void *context,int rs,int ra,int rb);

unsigned long *PowerPCIQ_STH(void *context,int rs,int ra,short offset);
unsigned long *PowerPCIQ_STHBRX(void *context,int rs,int ra,int rb);
unsigned long *PowerPCIQ_STHU(void *context,int rs,int ra,short offset);
unsigned long *PowerPCIQ_STHUX(void *context,int rs,int ra,int rb);
unsigned long *PowerPCIQ_STHX(void *context,int rs,int ra,int rb);

unsigned long *PowerPCIQ_STMW(void *context,int rs,int ra,short offset); // SYNC
unsigned long *PowerPCIQ_STSWI(void *context,int rs,int ra,int nb); // SYNC
unsigned long *PowerPCIQ_STSWX(void *context,int rs,int ra,int rb); // SYNC

unsigned long *PowerPCIQ_STW(void *context,int rs,int ra,short offset);
unsigned long *PowerPCIQ_STWBRX(void *context,int rs,int ra,int rb);
unsigned long *PowerPCIQ_STWU(void *context,int rs,int ra,short offset);
unsigned long *PowerPCIQ_STWUX(void *context,int rs,int ra,int rb);
unsigned long *PowerPCIQ_STWX(void *context,int rs,int ra,int rb);

unsigned long *PowerPCIQ_SUBF_(void *context,int rd,int ra,int rb,int OE,int Rc);
unsigned long *PowerPCIQ_SUBFC_(void *context,int rd,int ra,int rb,int OE,int Rc);
unsigned long *PowerPCIQ_SUBFE_(void *context,int rd,int ra,int rb,int OE,int Rc);
#define PowerPCIQ_SUB(context,rd,ra,rb,Rc)		PowerPCIQ_SUBF_(context,rd,rb,ra,0,Rc)
#define PowerPCIQ_SUBF(context,rd,ra,rb,Rc)		PowerPCIQ_SUBF_(context,rd,ra,rb,0,Rc)
#define PowerPCIQ_SUBFC(context,rd,ra,rb,Rc)	PowerPCIQ_SUBFC_(context,rd,ra,rb,0,Rc)
#define PowerPCIQ_SUBFCO(context,rd,ra,rb,Rc)	PowerPCIQ_SUBFC_(context,rd,ra,rb,0,Rc)
#define PowerPCIQ_SUBFE(context,rd,ra,rb,Rc)	PowerPCIQ_SUBFE_(context,rd,ra,rb,0,Rc)
#define PowerPCIQ_SUBFEO(context,rd,ra,rb,Rc)	PowerPCIQ_SUBFE_(context,rd,ra,rb,0,Rc)
#define PowerPCIQ_SUBFO(context,rd,ra,rb,Rc)	PowerPCIQ_SUBF_(context,rd,ra,rb,0,Rc)

unsigned long *PowerPCIQ_SUBFIC(void *context,int rd,int ra,short immediate);

unsigned long *PowerPCIQ_TW(void *context,int to,int ra,int rb); // SYNC
unsigned long *PowerPCIQ_TWI(void *context,int to,int ra,unsigned short immediate); // SYNC
#define PowerPCIQ_TRAP(context)		PowerPCIQ_TW(31,0,0)

unsigned long *PowerPCIQ_XOR(void *context,int rd,int ra,int rb,int Rc);
unsigned long *PowerPCIQ_XORI(void *context,int rd,int ra,unsigned short immediate);
unsigned long *PowerPCIQ_XORIS(void *context,int rd,int ra,unsigned short immediate);
